#####################################################################################################
#
#		.::[  The Russian Official Source Portal Of EggDrop  ]::. 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___       ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \     / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ /_/   \___/    
#        /___/ /___/                 /_/    /_/                
#
#
#####################################################################################################
#
# loc.tcl 1.0
#
# :
#          
# 
# :     scripts
#  eggdrop.conf  source scripts/loc.tcl
# 
#####################################################################################################
if { ![info exists egglib(ver)] } {
	putlog "***********************************************"
	putlog "             egglib_pub NOT FOUND !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
	putlog "***********************************************"	
	die
}

if { [expr {$egglib(ver) < 1.53}] } {
	putlog "***********************************************"
	putlog " YOUR VERSION OF egglib_pub IS TOO OLD !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.ru/modules/Files/Public/egglib.zip"
	putlog "***********************************************"
	putlog " version installed : $egglib(ver)"
	putlog " version required: 1.53"
	die
}
#####################################################################################################
foreach { p } [array names loc *] { unset loc($p) }
#####################################################################################################
foreach { b } [binds "::loc::*"] { unbind [lindex $b 0] [lindex $b 1] [lindex $b 2] [lindex $b 4]}
#####################################################################################################
namespace eval loc {}
#####################################################################################################
set loc(pref) "!"
set loc(authors) "\002hunt\002@\002RusNet\002 <\037hunt@eggdrop.ru\037>"
set loc(ver) "\037\0021.0.0\002\037"
#####################################################################################################
bind pub -|-	${loc(pref)}loc			::loc::pub
bind pub -|-	${loc(pref)}			::loc::pub
bind msg -|-	${loc(pref)}loc			::loc::msg
bind msg -|-	${loc(pref)}			::loc::msg
bind pub -|-	${loc(pref)}			::loc::pub
bind msg -|-	${loc(pref)}			::loc::msg
#####################################################################################################
setudef flag nopubloc
#####################################################################################################
set loc(names) {
	"" "" "" "  "
	"" "" "" ""
	"  " "" "" ""
	"" "" "" ""
	"" "" "" ""
	"" "" "" ""
	"" "" "" ""
	" " "" "   " " "
	"" "-" "" ""
	"" "" "" "   "
	" " " " "" ""
	"" " " "  ( )" ""
	" " "" " " "-"
	"-'" "" "" ""
	"" "" "" ""
	" " " " " " ""
	"" "" " " ""
	"" " " "" " "
	"" "" "" " "
	" " "  " "" ""
	"" "" "" ""
    "" "" " " ""
    " " "" "" ""
    " " "" "" "    "
    "" "" "" ""
	"" "" "" ""
	"" "" "" ""
    "" "" "" ""
    "" " " " " ""
	"" "" "" ""
    "" "" "  " ""
    "" "" "" ""
	"" "" "" ""
    "" "" " " ""
    "" "" "" ""
	"" "" "" ""
    "" "" "" ""
    "" "" "" "  "
    " " " " " " ""
    "" "" "" " "
    "  " "" "" ""
    "" "" "- " ""
    "" "" "" ""
	"" "-" "" ""
    "" " " "" "-  "
    "-" "-  " " " "-"
    "   " " " "" " "
    "-" "" "" " "
    "" " " "" " "
    "-. " "-  " "" ""
	"    " "" "" ""
    " " "  " "" ""
    "" "" "" ""
    "" "  " "" ""
    "" "   " "" ""
    "" "  " "" ""
	"" "    " ""
    " " "" "" "" ""
    "" "  ()" "  ()" "   "
    " " "" "" ""
    "" "" "  ()" "  ()"
	"  ()" "  ()" "  ()"
    " ()" " -   " " "
    "   " "" "" "" "  -   IP"
  }


  set loc(domains) {
	AF AL DZ AS AD AO AI AQ AG AR AM AW AU AT AZ BS BH BD BB BY BE
	BZ BJ BM BT BO BA BW BV BR IO BN BG BF BI BY KH CM CA CV KY CF
	TD CL CN CX CC CO KM CG CK CR CI HR HR CU CY CS DK DJ DM DO TP
	EC EG SV GQ EE ET FK FK FO FJ FI FR GF PF TF GA GM GE DE DE GH
	GI GR GL GD GP GU GT GN GW GY HT HM HN HK HU IS IN ID IR IQ IE
	IL IT JM JP JO KZ KE KI KP KR KW KG LA LV LB LS LR LY LI LT LU
	MO MK MG MW MY MV ML MT MH MQ MR MU MX FM MD MC MN MS MA MZ MM
	NA NR NP NL AN NT NC NZ NI NE NG NU NF MP NO OM PK PW PA PG PY
	PE PH PN PL PT PR QA RE RO RU RW KN LC VC WS SM ST SA SN SC SL
	SG SI SB SO ZA ES LK SH PM SD SR SJ SZ SE CH CH SY TW TJ TZ TH
	TG TK TO TT TN TR TM TC TV UG UA AE UK GB US UM UY SU UZ VU VA
	VE VN VI VG WF EH YE YU ZR ZM ZW COM EDU NET MIL ORG GOV KP KR
	LA SU SK CZ LO
  }
   
set loc(local) {
10.
172.16.
172.31.
192.168.
127.
}
                                                                            
proc ::loc::pub {nick uhost hand chan args} {
if {[channel get $chan nopubloc]} {return}
if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] } 
::loc::loc $nick $uhost $hand $chan $args
}

proc ::loc::msg {nick uhost hand args} { 
if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
::loc::loc $nick $uhost $hand $nick $args
}

proc ::loc::loc {nick uhost hand chan text} {
	global loc	
set hostip [lindex $text 0]
if {$text == ""} { ::egglib::outh $nick $chan "!loc" "ip\\nick\\host"
return
}
if {$hostip == ""} { ::egglib::outh $nick $chan "!loc" "ip\\nick\\host"
return
}
if {[validchan $chan]} {
if {[onchan $hostip $chan]} {
set nik $hostip	
set hostip [lindex [split [getchanhost $hostip $chan] "@"] 1]
} else {
set nik 0	
set hostip $hostip
}
} else {
set nik 0	
set hostip $hostip
}	
dnslookup $hostip ::loc::resolve $hostip $nick $uhost $hand $chan $nik
}

proc ::loc::resolve {aip ahost astatus hostip nick uhost hand chan nik} {
global loc
::egglib::log $nick $chan "locator" "$hostip"
	if {$astatus == "0"} {
	if {[string match "*.*.*.*" $hostip]} { set aip $hostip } }
  	set result [exec whois $aip]
  	set cnt ""
  	foreach s [split $result \n] { 
	if { [regexp -nocase -- {.*address:(.*)} $s garb found] } {	
    set found [::loc::rus [::loc::city $found]]
    regexp -nocase -- {^(\w+.*)} $found gr found
    if {$found != ""} { set city [tab $found] }
	} else {		
	if {[regexp -nocase -- {.*city:(.*)} $s garb found]} {
	if {$found != ""} { set city [string totitle $found]; regsub -all -- {^\ +} $city {} city }
	} else {
	if { [regexp -nocase -- {.*descr:(.*)} $s garb found] } {	
    set found [::loc::rus [::loc::city $found]]
    regexp -nocase -- {^(\w+.*)} $found gr found
    if {$found != ""} { set city [tab $found] }			
	}
	}
	}
	if {[regexp -nocase -- {.*country:(.*)} $s garb country]} {
	if {$country != ""} { set cnt [tab [::loc::cnt $country]] } else { set cnt "" }
	}
	}
	set local [::loc::local $aip]
	if {$local == 0} {
	if {[lindex [::loc::exceptions $ahost] 0] == 1} {
	set city [lindex [::loc::exceptions $ahost] 1]
	set cnt [lindex [::loc::exceptions $ahost] 2]
	set aip [lindex [::loc::exceptions $ahost] 3]
	}			
	if {($aip == "" && $cnt == "") || $aip == "0.0.0.0" || $aip == "" || ![info exists cnt] || $cnt == ""} {
	set hostip [::egglib::host_color $hostip]	
	if {$nik == 0} {
	::egglib::out $nick $chan ",       $hostip"
	return
	} else {
	::egglib::out $nick $chan ",       \0036$nik\00310($hostip\00310)\003"
	return
	}
	}
	}
  	if {$local == 1} { set cnt "LO"; set city "" }
  	if { [set idx [lsearch -exact $loc(domains) [string toupper $cnt]]] != -1 } {	
  	set domen [string map {  i I p P} [string totitle [lindex $loc(names) $idx]]]}
  	set cnt [::egglib::toupper $cnt]
  	if {$domen == ""} { set domen "" }
  	set aip [::egglib::host_color $aip]
  	if {$nik != 0} {	
  	if {[info exists city] && $city != ""} {		
	set out "\00306$nik\00310(\003$aip\00310)\003   \00304$cnt\003 \00305=> \00306$domen, \00305[string totitle $city]\003"
	} else {
	set out "\00313$nik\00310(\003$aip\00310)\003   \00304$cnt\003 \00305=> \00306$domen\003"
	}
	}
	if {$nik == 0} {
	if {[info exists city] && $city != ""} { 
	set out "$aip   \00304$cnt\003 \00305=> \00306$domen, \00305[string totitle $city]\003"
	} else {
	set out "$aip   \00304$cnt\003 \00305=> \00306$domen\003"	 
	}	
	}	
  	::egglib::out $nick $chan $out
	}
	
	proc ::loc::cnt {t} {
	regsub -all -- {\n} $t {} t
	regsub -all -- {^\ +} $t {} t
	regsub -all -- {\ +} $t {} t
	return $t
	}
	
		proc ::loc::city {t} {
		set t [::egglib::strip_special $t]
		regsub -all -- {\d+} $t {} t
		regsub -all -- {\n} $t {} t
		regsub -all -- {\n+} $t "\n" t
		regsub -all -- {\ +} $t {} t
		regsub -all -- {\t} $t {} t
		regsub -all -- {^\ +} $t {} t	
		regsub -nocase -- {.*abakan.*$} $t {} t	
		regsub -nocase -- {.*algiers.*$} $t {} t
		regsub -nocase -- {.*Arkhangelsk.*$} $t {} t
		regsub -nocase -- {.*astrahan.*$} $t {} t                                                                 
		regsub -nocase -- {.*athens.*$} $t 	{} t
		regsub -nocase -- {.*baghdad.*$} $t {} t
		regsub -nocase -- {.*barnaul.*$} $t {} t
		regsub -nocase -- {.*Belgrade.*$} $t {} t
		regsub -nocase -- {.*lagoveschensk.*$} $t {} t
		regsub -nocase -- {.*berezniki.*$} $t {} t
		regsub -nocase -- {.*biysk.*$} $t {} t
		regsub -nocase -- {.*bratsk.*$} $t {} t
		regsub -nocase -- {.*brest.*$} $t {} t
		regsub -nocase -- {.*sosnovoborsk.*$} $t {} t
		regsub -nocase -- {.*bryansk.*$} $t {} t
		regsub -nocase -- {.*novgorod.*$} $t {} t
		regsub -nocase -- {.*Warszawa.*$} $t {} t
		regsub -nocase -- {.*vitebsk.*$} $t {} t
		regsub -nocase -- {.*vladikavkaz.*$} $t {} t
		regsub -nocase -- {.*vladimir.*$} $t {} t
		regsub -nocase -- {.*volgograd.*$} $t {} t
		regsub -nocase -- {.*vologda.*$} $t {} t
		regsub -nocase -- {.*vorkuta.*$} $t {} t
		regsub -nocase -- {.*gomel.*$} $t {} t
		regsub -nocase -- {.*gorno-altaisk.*$} $t {-} t
		regsub -nocase -- {.*greenwich.*$} $t {} t
		regsub -nocase -- {.*groz.*$} $t {} t
		regsub -nocase -- {.*grodno.*$} $t {} t
		regsub -nocase -- {.*dakar.*$} $t {} t
		regsub -nocase -- {.*delhi.*$} $t {} t
		regsub -nocase -- {.*dudinka.*$} $t {} t
		regsub -nocase -- {.*eka.*?burg.*$} $t {} t
		regsub -nocase -- {.*izhevsk.*$} $t { } t
		regsub -nocase -- {.*irkutsk.*$} $t {} t
		regsub -nocase -- {.*tyumen.*$} $t {} t
		regsub -nocase -- {.*ioshkar.*?Ola.*$} $t {-} t
		regsub -nocase -- {.*magadan.*$} $t {} t
		regsub -nocase -- {.*magas.*$} $t {} t
		regsub -nocase -- {.*kazan.*$} $t {} t
		regsub -nocase -- {.*kgts.*$} $t {} t
		regsub -nocase -- {.*kaliningrad.*$} $t {} t
		regsub -nocase -- {.*kabul.*$} $t {} t
		regsub -nocase -- {.*cair.*$} $t {} t
		regsub -nocase -- {.*kaluga.*$} $t {} t
		regsub -nocase -- {.*kenerovo.*$} $t {} t
		regsub -nocase -- {.*Sosnovy.*Bor.*$} $t {} t
		regsub -nocase -- {.*kinshasa.*$} $t {} t
		regsub -nocase -- {.*kislovodsk.*$} $t {} t
		regsub -nocase -- {.*kirov.*$} $t {} t
		regsub -nocase -- {.*kostroma.*$} $t {} t
		regsub -nocase -- {.*krasnodar.*$} $t {} t
		regsub -nocase -- {.*krasnoyarsk.*$} $t {} t
		regsub -nocase -- {.*kudymkar.*$} $t {} t
		regsub -nocase -- {.*kursk.*$} $t {} t
		regsub -nocase -- {.*kurgan.*$} $t {} t
		regsub -nocase -- {.*kyzyl.*$} $t {} t
		regsub -nocase -- {.*the netherlands.*$} $t {} t
		regsub -nocase -- {.*lagos.*$} $t {} t
		regsub -nocase -- {.*lipeck.*$} $t {} t
		regsub -nocase -- {.*london.*$} $t {} t
		regsub -nocase -- {.*magnitogorsk.*$} $t {} t
		regsub -nocase -- {.*madrid.*$} $t {} t
		regsub -nocase -- {.*mahachkala.*$} $t {} t
		regsub -nocase -- {.*minsk.*$} $t {} t
    	regsub -nocase -- {.*mogilev.*$} $t {} t
    	regsub -nocase -- {.*moscow.*$} $t {} t
	regsub -nocase -- {.*mosk.*ob.*$} $t { } t
    	regsub -nocase -- {.*murmansk.*$} $t {} t  
    	regsub -nocase -- {.*naberezhnye.*?.*$} $t {-} t  
    	regsub -nocase -- {.*lower*novgorod.*$} $t { } t  
    	regsub -nocase -- {.*novosibirsk.*$} $t {} t  
    	regsub -nocase -- {.*odessa.*$} $t {} t
    	regsub -nocase -- {^omsk.*$} $t {} t
    	regsub -nocase -- {.*orenburg.*$} $t {} t
    	regsub -nocase -- {.*Oryol.*$} $t {} t
    	regsub -nocase -- {.*samara.*$} $t {} t
    	regsub -nocase -- {^rom.*$} $t {} t
	regsub -nocase -- {.*Odincovo.*$} $t {} t
    	regsub -nocase -- {.*penza.*$} $t {} t
    	regsub -nocase -- {.*pskov.*$} $t {} t
    	regsub -nocase -- {.*riga.*$} $t {} t
    	regsub -nocase -- {.*saratov.*$} $t {} t
    	regsub -nocase -- {.*salehard .*$} $t {} t                                     
    	regsub -nocase -- {.*sevas.*$} $t {} t
    	regsub -nocase -- {.*Sa.*Peter.*} $t {-} t
    	regsub -nocase -- {.*togliatti.*$} $t {} t
    	regsub -nocase -- {.*Syktyvkar.*$} $t {} t
    	regsub -nocase -- {.*Khabarovsk.*$} $t {} t
    	regsub -nocase -- {.*elista.*$} $t {} t
    	regsub -nocase -- {.*chita.*$} $t {} t
    	regsub -nocase -- {.*anadyr.*$} $t {} t
    	regsub -nocase -- {.*ostov.*on.*Don.*$} $t {--} t
		regsub -nocase -- {.*Seversk.*$} $t {} t                        
    	regsub -nocase -- {.*tomsk.*$} $t {} t
    	regsub -nocase -- {.*lan.*ud.*$} $t {-} t
    	regsub -nocase -- {.*ufa.*$} $t {} t
    	regsub -nocase -- {.*saransk.*$} $t {} t                                                                 
    	regsub -nocase -- {.*chelyabinsk.*$} $t {} t                                                                    
    	regsub -nocase -- {.*uliyanovsk.*$} $t {} t       
    	regsub -nocase -- {.*yaroslavl.*$} $t {} t
    	regsub -nocase -- {.*cheboksar.*$} $t {} t
    	regsub -nocase -- {.*cherkessk.*$} $t {} t
    	regsub -nocase -- {.*tambov.*$} $t {} t
    	regsub -nocase -- {.*zelenograd.*$} $t {} t
    	regsub -nocase -- {.*tagan.*$} $t {} t
    	regsub -nocase -- {.*soch.*$} $t {} t
    	regsub -nocase -- {.*petrozavod.*$} $t {} t
    	regsub -nocase -- {.*samara.*.*$} $t {} t
    	regsub -nocase -- {.*tula.*$} $t {} t
    	regsub -nocase -- {.*aterloo.*$} $t {} t
    	regsub -nocase -- {.*harkov.*$} $t {} t
    	regsub -nocase -- {.*dn.*propetrovsk.*$} $t {} t
    	regsub -nocase -- {.*donetsk.*$} $t {} t
    	regsub -nocase -- {.*Zaporizhzhe.*$} $t {} t
    	regsub -nocase -- {.*lviv.*$} $t {} t
    	regsub -nocase -- {.*kryvyi rih.*$} $t { } t
    	regsub -nocase -- {.*mykolaiv.*$} $t {} t
    	regsub -nocase -- {.*mariupol.*$} $t {} t
    	regsub -nocase -- {.*Luhansk.*$} $t {} t
    	regsub -nocase -- {.*Makiivka.*$} $t {} t
    	regsub -nocase -- {.*Simferopol.*$} $t {} t
    	regsub -nocase -- {.*Kherson.*$} $t {} t
    	regsub -nocase -- {.*Poltava.*$} $t {} t
    	regsub -nocase -- {.*Chernihiv.*$} $t {} t
    	regsub -nocase -- {.*Cherkasy.*$} $t {} t
    	regsub -nocase -- {.*Sumy.*$} $t {} t
    	regsub -nocase -- {.*Horlivka.*$} $t {} t
    	regsub -nocase -- {.*Zhytomyr.*$} $t {} t
    	regsub -nocase -- {.*Dniprodzerzhynsk.*$} $t {} t
    	regsub -nocase -- {.*Kirovohrad.*$} $t {} t
    	regsub -nocase -- {.*Khmelnytskyi.*$} $t {} t
    	regsub -nocase -- {.*Rivne.*$} $t {} t
    	regsub -nocase -- {.*Chernivtsi.*$} $t {} t
    	regsub -nocase -- {.*Kremenchuk.*$} $t {} t
    	regsub -nocase -- {.*Ternopil.*$} $t {} t
    	regsub -nocase -- {.*Ivano.*Frankivsk.*$} $t {-} t
    	regsub -nocase -- {.*Minsk.*$} $t {} t 
    	regsub -nocase -- {.*Yalta.*$} $t {} t
    	regsub -nocase -- {.*Kuznetsovsk.*$} $t {} t
    	regsub -nocase -- {.*blakovo.*$} $t {} t
    	regsub -nocase -- {.*Krasnohrad.*$} $t {} t
    	regsub -nocase -- {.*Chornobyl.*$} $t {} t
    	regsub -nocase -- {.*MUNICH.*$} $t {} t
    	regsub -nocase -- {.*FRANKFURT.*$} $t {} t
    	regsub -nocase -- {.*AUGSBURG.*$} $t {} t
    	regsub -nocase -- {.*GARMISCH-PARTENKIRCHEN.*$} $t {-} t
    	regsub -nocase -- {.*BERLIN.*$} $t {} t
		regsub -nocase -- {.*HAMBURG.*$} $t {} t
		regsub -nocase -- {.*AACHEN.*$} $t {} t
		regsub -nocase -- {.*AALEN.*$} $t {} t
		regsub -nocase -- {.*ALTENSTEIG.*$} $t {} t
		regsub -nocase -- {.*ALZEY.*$} $t {} t
		regsub -nocase -- {.*AMBERG.*$} $t {} t
		regsub -nocase -- {.*ANSBACH.*$} $t {} t
		regsub -nocase -- {.*ASCHHEIM-DORNACH.*$} $t {-} t
		regsub -nocase -- {.*ASSMANNSHAUSEN.*$} $t {} t
		regsub -nocase -- {.*DUSSELDORF.*$} $t {} t
		regsub -nocase -- {.*.*$} $t {} t
		regsub -nocase -- {.*DRESDEN.*$} $t {} t
		regsub -nocase -- {.*WALLUF.*$} $t {} t
		regsub -nocase -- {.*OBERURSEL.*$} $t {} t
		regsub -nocase -- {.*Weimar.*$} $t {} t
		regsub -nocase -- {.*Fuerth.*$} $t {} t
		regsub -nocase -- {.*Nideggen.*$} $t {} t
		regsub -nocase -- {.*Heidelberg.*$} $t {} t
		regsub -nocase -- {.*potsdam.*$} $t {} t
		regsub -nocase -- {.*Koeln.*$} $t {ʸ} t
		regsub -nocase -- {.*voronez.*$} $t {} t
		regsub -nocase -- {.*Perm.*$} $t {} t
		regsub -nocase -- {.*Simbirsk.*$} $t {} t
		regsub -nocase -- {.*Barnaul.*$} $t {} t
		regsub -nocase -- {.*Vladivostok.*$} $t {} t
		regsub -nocase -- {.*Orenburg.*$} $t {} t
		regsub -nocase -- {.*Novokuznetsk.*$} $t {} t
		regsub -nocase -- {.*Ryazan.*$} $t {} t
		regsub -nocase -- {.*Magnitogorsk.*$} $t {} t
		regsub -nocase -- {.*Nizhny.*Tagil.*$} $t { } t
		regsub -nocase -- {.*stavropol.*$} $t {} t
		regsub -nocase -- {.*Smolensk.*$} $t {} t
		regsub -nocase -- {.*Murmansk.*$} $t {} t
		regsub -nocase -- {.*Vladikavkaz.*$} $t {} t
		regsub -nocase -- {.*Surgut.*$} $t {} t
		regsub -nocase -- {.*Vologda.*$} $t {} t
		regsub -nocase -- {.*Nalchik.*$} $t {} t
		regsub -nocase -- {.*Komsomolsk-on-Amur.*$} $t {--} t
		regsub -nocase -- {.*Sterlitamak.*$} $t {} t
		regsub -nocase -- {.*Dzerzhinsk.*$} $t {} t
		regsub -nocase -- {.*Orsk.*$} $t {} t
		regsub -nocase -- {.*Nizhnevartovsk.*$} $t {} t
		regsub -nocase -- {.*Angarsk.*$} $t {} t
		regsub -nocase -- {.*Novorossiysk.*$} $t {} t
		regsub -nocase -- {.*Nizhnekamsk.*$} $t {} t
		regsub -nocase -- {.*Stary Oskol.*$} $t { } t
		regsub -nocase -- {.*Blagoveshchensk.*$} $t {} t
		regsub -nocase -- {.*Rybinsk.*$} $t {} t
		regsub -nocase -- {.*Biysk.*$} $t {} t
		regsub -nocase -- {.*Prokopyevsk.*$} $t {} t
		regsub -nocase -- {.*Yakutsk.*$} $t {} t
		regsub -nocase -- {.*Balakovo.*$} $t {} t
		regsub -nocase -- {.*Kedrovy .*$} $t {} t
		regsub -nocase -- {.*Magadan .*$} $t {} t
		regsub -nocase -- {.*Nazran .*$} $t {} t
		regsub -nocase -- {.*Neftekamsk .*$} $t {} t
		regsub -nocase -- {.*Tobolsk.*$} $t {} t
		regsub -nocase -- {.*Vorkuta .*$} $t {} t
		regsub -nocase -- {.*Yuzhno-Sakhalinsk .*$} $t {-} t
		regsub -nocase -- {.*Vyborg.*$} $t {} t
		regsub -nocase -- {.*Akkol'.*} $t {} t
		regsub -nocase -- {.*Alatau.*} $t {} t
		regsub -nocase -- {.*Ak-Mechet.*} $t {-} t
		regsub -nocase -- {.*Almaty.*} $t {} t
		regsub -nocase -- {.*Aqtas.*} $t {} t
		regsub -nocase -- {.*Aqtau.*} $t {} t
		regsub -nocase -- {.*Aqtobe.*} $t {} t
		regsub -nocase -- {.*Aralsk.*} $t {} t
		regsub -nocase -- {.*Arkalyk.*} $t {} t
		regsub -nocase -- {.*Astana.*} $t {} t
		regsub -nocase -- {.*Atyrau.*} $t {} t
		regsub -nocase -- {.*Ayaguz.*} $t {} t
		regsub -nocase -- {.*Balkash.*} $t { (} t
		regsub -nocase -- {.*Beyneu.*} $t {} t
		regsub -nocase -- {.*Baikonur.*} $t {} t
		regsub -nocase -- {.*Chapayev.*} $t {} t
		regsub -nocase -- {.*Chemolgan.*} $t {} t
		regsub -nocase -- {.*Chu.*} $t {} t
		regsub -nocase -- {.*Ekibastuz.*} $t {} t
		regsub -nocase -- {.*Emba.*} $t {} t
		regsub -nocase -- {.*Fort.*} $t {} t
		regsub -nocase -- {.*Karaganda.*} $t {} t
		regsub -nocase -- {.*Khorogos.*} $t {} t
		regsub -nocase -- {.*Kizilyar.*} $t {} t
		regsub -nocase -- {.*Koksetau.*} $t { (} t
		regsub -nocase -- {.*Kostanai.*} $t {} t
		regsub -nocase -- {.*Oktyabr'sk.*} $t {} t
		regsub -nocase -- {.*Oral.*} $t {} t
		regsub -nocase -- {.*Oskemen.*} $t {} t
		regsub -nocase -- {.*Pavlodar.*} $t {} t
		regsub -nocase -- {.*Petropavl.*} $t {}  t
		regsub -nocase -- {.*Qazaly.*} $t {} t
		regsub -nocase -- {.*Qyzylorda.*} $t {} t
		regsub -nocase -- {.*Ridder.*} $t {} t
		regsub -nocase -- {.*Rudniy.*} $t {} t
		regsub -nocase -- {.*Saryshagan.*} $t {} t
		regsub -nocase -- {.*Satpaev.*} $t {} t
		regsub -nocase -- {.*Semey.*} $t {} t
		regsub -nocase -- {.*Shymkent.*} $t {} t
		regsub -nocase -- {.*Taldykorgan.*} $t {} t
		regsub -nocase -- {.*Taraz.*} $t {} t
		regsub -nocase -- {.*Temirtau.*} $t {} t
		regsub -nocase -- {.*Tyuratam.*} $t {} t
		regsub -nocase -- {.*Uralsk.*} $t {} t
		regsub -nocase -- {.*Turkestan.*} $t {} t
		regsub -nocase -- {.*Wasij.*} $t {} t
		regsub -nocase -- {.*Zaysan.*} $t {} t
		regsub -nocase -- {.*Zhana-Ozen.*} $t {-} t
		regsub -nocase -- {.*Zhezkazgan.*} $t {} t
		regsub -nocase -- {.*Zharkent.*} $t {} t
		regsub -nocase -- {.*Zyryan.*} $t {} t
		regsub -nocase -- {.*paris.*$} $t {} t
		regsub -nocase -- {.*amsterdam.*$} $t {} t
		regsub -nocase -- {.*Marseille.*$} $t {} t
		regsub -nocase -- {.*Prague.*$} $t {} t
		regsub -nocase -- {.*Budapest.*$} $t {} t
		regsub -nocase -- {.*Bucharest.*$} $t {} t
		regsub -nocase -- {.*Peking.*$} $t {} t
		regsub -nocase -- {.*Tashkent.*$} $t {} t
		regsub -nocase -- {.*Tokyo.*$} $t {} t
		regsub -nocase -- {.*Tbilisi.*$} $t {} t
		regsub -nocase -- {.*Tehran.*$} $t {} t
		regsub -nocase -- {.*Brussels.*$} $t {} t
		regsub -nocase -- {.*tokio.*$} $t {} t
		regsub -nocase -- {.*Karlsruhe.*$} $t {} t
		regsub -nocase -- {.*voro.*$} $t {} t
		regsub -nocase -- {.*kiev.*$} $t {} t
		regsub -nocase -- {.*Erfurt.*$} $t {} t
		regsub -nocase -- {.*Milano.*$} $t {} t
		regsub -nocase -- {.*Zelenodolsk.*$} $t {} t
		regsub -nocase -- {.*Podolsk.*$} $t {} t
		regsub -nocase -- {.*Votkinsk.*$} $t {} t
    		return [string totitle $t]
}   

proc ::loc::rus {t} {	
	regsub -all -- {a} $t {} t
	regsub -all -- {b} $t {} t
	regsub -all -- {c} $t {} t
	regsub -all -- {d} $t {} t
	regsub -all -- {e} $t {} t
	regsub -all -- {f} $t {} t
	regsub -all -- {g} $t {} t
	regsub -all -- {h} $t {} t
	regsub -all -- {i} $t {} t
	regsub -all -- {j} $t {} t
	regsub -all -- {k} $t {} t
	regsub -all -- {l} $t {} t
	regsub -all -- {m} $t {} t
	regsub -all -- {n} $t {} t
	regsub -all -- {o} $t {} t
	regsub -all -- {p} $t {} t	                         
	regsub -all -- {q} $t {} t
	regsub -all -- {r} $t {} t
	regsub -all -- {s} $t {} t
	regsub -all -- {t} $t {} t
	regsub -all -- {u} $t {} t
	regsub -all -- {v} $t {} t
	regsub -all -- {w} $t {} t
	regsub -all -- {x} $t {} t
	regsub -all -- {y} $t {} t
	regsub -all -- {z} $t {} t
	regsub -all -- {A} $t {} t
	regsub -all -- {B} $t {} t
	regsub -all -- {C} $t {} t
	regsub -all -- {D} $t {} t
	regsub -all -- {E} $t {} t
	regsub -all -- {F} $t {} t
	regsub -all -- {G} $t {} t
	regsub -all -- {H} $t {} t
	regsub -all -- {I} $t {} t
	regsub -all -- {J} $t {} t
	regsub -all -- {K} $t {} t
	regsub -all -- {L} $t {} t
	regsub -all -- {M} $t {} t
	regsub -all -- {N} $t {} t
	regsub -all -- {O} $t {} t
	regsub -all -- {P} $t {} t	                         
	regsub -all -- {Q} $t {} t
	regsub -all -- {R} $t {} t
	regsub -all -- {S} $t {} t
	regsub -all -- {T} $t {} t
	regsub -all -- {U} $t {} t
	regsub -all -- {V} $t {} t
	regsub -all -- {W} $t {} t
	regsub -all -- {X} $t {} t
	regsub -all -- {Y} $t {} t
	regsub -all -- {Z} $t {} t
	return $t
}
proc ::loc::exceptions {ahost} {	
	if {[string match "*academ.loc*" $ahost]} {set num 1; set city ""; set cnt "RU"; set aip "$ahost"}
	if {[string match "*sbor.net*" $ahost]} {set city ""; set cnt "RU"; set aip "$ahost"}
	if {[string match "*is74.loc*" $ahost]} {set city ""; set cnt "RU"; set aip "$ahost"}
	if {[string match "*ixx.ru*" $ahost]} {set city ""; set cnt "RU"; set aip "$ahost"}
	if {[string match "*homenet*" $ahost]} {set city ""; set cnt "RU"; set aip "$ahost"}
	if {[info exists city] && [info exists cnt] && [info exists aip]} { set num 1 } else { set num 0;set city ""; set cnt ""; set aip "" }
	return "$num $city $cnt $aip"
}
	
proc ::loc::local {h} {
global loc
foreach b $loc(local) {
set b [split $b]	
if {[string match "$b*" $h]} { set local 1;break } else { set local 0 }
}
return $local
}

proc ::loc::tab {t} {
regsub -all -- {\t} $t {} t
return $t
}
	 		
::egglib::srcloadlog "loc" "$loc(ver)" "$loc(authors)"
				




